#include "OgrePlatformOcclusionQuery.h"
#include <OgreLogManager.h>

namespace Ogre {

//-----------------------------------------------------------------------
PlatformOcclusionQuery::PlatformOcclusionQuery(RenderSystem *rsys)
{
	mHardwareOcclusionQuery = rsys->createHardwareOcclusionQuery();
}
//-----------------------------------------------------------------------
PlatformOcclusionQuery::~PlatformOcclusionQuery()
{
	delete mHardwareOcclusionQuery;
}
//-----------------------------------------------------------------------
void PlatformOcclusionQuery::BeginQuery()
{
	mHardwareOcclusionQuery->beginOcclusionQuery();
}
//-----------------------------------------------------------------------
void PlatformOcclusionQuery::EndQuery()
{
	mHardwareOcclusionQuery->endOcclusionQuery();
}
//-----------------------------------------------------------------------
bool PlatformOcclusionQuery::GetQueryResult(unsigned int &visiblePixels, 
											const bool waitForResult) const
{
	// return mHardwareOcclusionQuery->pullOcclusionQuery(&visiblePixels, waitForResult);

	bool isAvailable = true;

	if (!waitForResult)
		isAvailable = !mHardwareOcclusionQuery->isStillOutstanding();

	if (isAvailable)
		return mHardwareOcclusionQuery->pullOcclusionQuery(&visiblePixels);

	return isAvailable;
}

} // namespace Ogre